<?php

namespace App\domain\travelport;

use App\Models\Traveler;
use Illuminate\Http\Request;
use Illuminate\Support\Collection;

class AddTravellersInWorkbenchAction
{
    protected AddTravelerInWorkbench $addTravelerInWorkbench;

    protected int $traceId;

    public function __construct()
    {
        $this->addTravelerInWorkbench = new AddTravelerInWorkbench();
        $this->traceId = 5;
    }

    public function execute(string $reservationId, array $travellers): Collection
    {
        $travellerIds = new Collection;

        foreach ($travellers as $index => $traveller) {
            $response = $this->addTravelerInWorkbench->execute($reservationId, $traveller, $this->traceId ,$index+1);

            $travelerData = [
                "source" => "travelport",
                "travelerRef" => $traveller["Traveler"]["TravelerRef"],
                "personName" => json_encode($traveller["Traveler"]["PersonName"]),
                "email" => isset($traveller["Traveler"]["Email"]) ? json_encode($traveller["Traveler"]["Email"][0]["value"]) : null,
                "reservationIdentifier" => $reservationId,
                "travelerIdentifier" => $reservationId,
            ];

            $this->saveTraveler($travelerData);

            $travellerIds->add($travelerData);
        };
        return $travellerIds;
    }

    protected function saveTraveler(array $travelerData): void
    {
        Traveler::create($travelerData);
    }
}
