<?php

namespace App\domain\travelport;

use App\domain\travelport\traits\TravelportTokenTrait;
use App\Models\TravelportToken;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Session;

class SearchOfferAPI extends TravelportAPI
{
    use TravelportTokenTrait;

    protected function getHeaders(): array
    {
        Log::info("access_token : " . session('access_token'));

        $this->getTravelportTokens();

        if (!session()->has('access_token')) {
            Log::info("access_token expired : " . session('access_token'));

            $oAuthToken = new CreateOAuthTokens();
            $newOAuthToken = $oAuthToken->refreshOAuthAccessToken();

            Log::info("refresh token : " . session('refresh_token'));

            if (!$newOAuthToken) {

                Log::info("no refresh token : " . session('refresh_token'));
                $tokens = $oAuthToken->requestOAuthAccessToken();

                Log::info("New token: ", $tokens);
            }
        }

        return [
            'Accept' => 'application/json',
            'Accept-Encoding' => 'gzip, deflate, br',
            'Content-Type' => 'application/json',
//            'XAUTH_TRAVELPORT_ACCESSGROUP' => '07F63A7D-1826-42E5-8353-F5E40D3C9B41',
            'XAUTH_TRAVELPORT_ACCESSGROUP' => '261EB763-521C-4649-B343-905B2F19A3D0',
            'Accept-Version' => $this->apiVersion,
            'Content-Version' => $this->apiVersion,
            'Authorization' => 'Bearer ' . session('access_token'),
        ];
    }

    protected function getHeadersForContentLessRequest(): array
    {
        if (!session('access_token')) {
            $oAuthToken = new CreateOAuthTokens();
            $newOAuthToken = $oAuthToken->refreshOAuthAccessToken();

            if (!$newOAuthToken) {
                $tokens = $oAuthToken->requestOAuthAccessToken();
            }
        }

        return [
            'Accept' => 'application/json',
            'XAUTH_TRAVELPORT_ACCESSGROUP' => '261EB763-521C-4649-B343-905B2F19A3D0',
            'Accept-Version' => $this->apiVersion,
            'Content-Version' => $this->apiVersion,
            'Authorization' => 'Bearer ' . session('access_token'),
        ];
    }
}
