<?php

namespace App\domain\travelport\traits;

use App\Models\TravelportToken;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Session;

trait TravelportTokenTrait
{
    protected function getTravelportTokens(): void
    {
        $travelportTokens = TravelportToken::query()->first();

        Log::info("$travelportTokens db:". $travelportTokens);

        if (!$travelportTokens) return;

        $expireIn = Carbon::parse($travelportTokens->expire_in);

        if (now()->gte($expireIn)) {
            $travelportTokens->delete();

            return;
        }

        Log::info("Travelport tokens from db:", $travelportTokens->toArray());

        Session::put('access_token', $travelportTokens->access_token);
        Session::put('refresh_token', $travelportTokens->refresh_token);

    }
}
